from NanoTCAD_ViDES import *
from scipy.optimize import newton

def n_2D_Q(Phi,Temp,mu,mu2,chiSi,phiM,Vg):
    me=(0.19*0.98*0.98)**(1/3.0)*m0;
    Ej=(3*2*pi*hbar*q*3.9/11.8*abs(Vg-Phi)/tox/(4*sqrt(2*0.19*m0))*(3/4.0))**(2/3.0)/q
    Ec=phiM-chiSi-Phi+Ej
    return -6*(kboltz*Temp)*me/pi/hbar**2*log(1+exp((mu-Ec)/(kboltz*Temp/q)));

def n_2D_Q_TOB(Phi,Temp,mu,mu2,chiSi,phiM,Vg):
    me=(0.19**0.98*0.98)**(1/3.0)*m0;
    Ej=(3*2*pi*hbar*q*3.9/11.8*abs(Vg-Phi)/tox/(4*sqrt(2*0.19*m0))*(3/4.0))**(2/3.0)/q
    Ec=phiM-chiSi-Phi+Ej
    return 0.5*(-6*(kboltz*Temp)*me/pi/hbar**2*log(1+exp((mu-Ec)/(kboltz*Temp/q)))-6*(kboltz*Temp)*me/pi/hbar**2*log(1+exp((mu2-Ec)/(kboltz*Temp/q))));

def n_SC(Phi,Temp,mu,mu2,chiSi,phiM,Vg):
    me=(0.19**0.98*0.98)**(1/3.0)*m0;
    Ec=phiM-chiSi-Phi
    epsSi=11.8*eps0;
    return -6*(2*me*kboltz*Temp/hbar**2)**1.5*exp(-(Ec-mu)/(kboltz*Temp/q))*sqrt(2*q*epsSi*Na*abs(Phi))/q/Na

def Nam(Phi,epsSi,Na):
    if (Phi>0):
        return -sqrt(2*q*epsSi*Na*abs(Phi))/q
    else:
        return 0;

def rho_tot(Phi,Temp,mu,mu2,chiSi,phiM,Na,Vg):
    Ec=phiM-chiSi-Phi
    epsSi=11.8*eps0;
    return n_2D_Q(Phi,Temp,mu,mu2,chiSi,phiM,Vg)+Nam(Phi,epsSi,Na);

def eq1(Phi,Vg1,C1,Temp,mu,mu2,chiSi,phiM,Na):
    Ec=phiM-chiSi-Phi
    charge=rho_tot(Phi,Temp,mu,mu2,chiSi,phiM,Na,Vg1);
    return C1*(Vg1-Phi)+q*(charge);

def current(Phi,Temp,mu1,mu2,chiSi,phiM,W):
    me=(0.19**0.98*0.98)**(1/3.0)*m0;
    Ej=(3*2*pi*hbar*q*3.9/11.8*abs(Vg-Phi)/tox/(4*sqrt(2*0.19*m0))*(3/4.0))**(2/3.0)/q
    Ec=phiM-chiSi-Phi+Ej
    vt=kboltz*Temp/q;
    J=q*sqrt(2*me)*(kboltz*Temp)**1.5/(pi**2*hbar**2)*sqrt(pi)/2*(Fermi_Integrals(0.5,(mu1-Ec)/vt)-Fermi_Integrals(0.5,(mu2-Ec)/vt))
    return J;

chiSi=4.1
phiM=4.1;
tox=1e-9;
C1=3.9*eps0/tox;
Temp=300;
Vg=-4;
mu1=0.0
Vds=0.1
mu2=-Vds
L=1e-6;
W=4e-6;
Na=1e24; 

dV=0.1;
VG=[];
pot_c=[];
Q=[]
I=[];
Phi1=Vg;
err1=1e3;
err2=1e3;
while (Vg<5):
    Phi1=newton(eq1,Phi1,fprime=None,args=(Vg,C1,Temp,mu1,mu2,chiSi,phiM,Na),tol=1e-8,maxiter=40000)
    print "Vg = ",Vg,-Phi1,(3*2*pi*hbar*q*11.8/3.9*abs(Vg-Phi1)/tox/(4*sqrt(2*m0))*(3/4.0))**(2/3.0)/q
    VG.append(Vg);
    Q.append(rho_tot(Phi1,Temp,mu1,mu2,chiSi,phiM,Na,Vg))
    I.append(current(Phi1,Temp,mu1,mu2,chiSi,phiM,W))
    pot_c.append(Phi1);
    Vg=Vg+dV;

VG=array(VG);
pot_c=array(pot_c);
Q=array(Q);
I=array(I)

#a=loadtxt("Q_SC.out");
#plot(a[:,0],abs(a[:,1]));

plot(VG,pot_c);
show()

#a=[VG,Q]
#savetxt("Q_SC.out",transpose(a));
